import { Component, OnInit, Input, ViewChild, ElementRef, AfterViewInit } from '@angular/core';
import { animate, AnimationBuilder, AnimationFactory, AnimationPlayer, style } from '@angular/animations';

@Component({
  selector: 'ati-destination',
  templateUrl: './destination.component.html',
  styleUrls: ['./destination.component.scss']
})
export class DestinationComponent implements OnInit,  AfterViewInit {

  items: any;
  type: any;
  @ViewChild('carousel', {static: false}) private carousel: ElementRef;
  @Input() timing = '750ms ease-in';
  @Input() showControls = true;
  private player: AnimationPlayer;
  private itemWidth: number;
  private currentSlide = 0;
  carouselWrapperStyle = {};
  slideWidth: any;

  constructor(private builder: AnimationBuilder) {
    this.type = 'destination';
  }

  ngOnInit() {
    this.items = [
      { place: 'Paris', price: '213', image:"../../../assets/destination/paris.png"},
      { place: 'Dubai', price: '521', image: "../../../assets/destination/dubai.png" },
      { place: 'Dummy one', price: '121', image: "../../../assets/destination/paris.png" },
      { place: 'Dummy two', price: '75', image: "../../../assets/destination/dubai.png" },
      { place: 'Dummy three', price: '857', image: "../../../assets/destination/paris.png" },
      { place: 'Dummy four', price: '263', image: "../../../assets/destination/dubai.png" },
      { place: 'Dummy five', price: '145', image: "../../../assets/destination/paris.png" },
      { place: 'Dummy six', price: '1252', image: "../../../assets/destination/dubai.png" },
    ]
  }

  next() {
    this.currentSlide = (this.currentSlide + 1) % this.items.length;
    const offset = this.currentSlide * this.itemWidth;
    const myAnimation: AnimationFactory = this.buildAnimation(offset);
    this.player = myAnimation.create(this.carousel.nativeElement);
    this.player.play();
  }

  private buildAnimation(offset) {
    return this.builder.build([
      animate(this.timing, style({ transform: `translateX(-${offset}px)` }))
    ]);
  }

  ngAfterViewInit() {
    const count = this.items.length;
    this.slideWidth = count * this.itemWidth;
    setTimeout(() => {
      // this.itemWidth = this.itemsElements.first.nativeElement.getBoundingClientRect().width;
      this.itemWidth = window.innerHeight;
      console.log(this.itemWidth);
      this.carouselWrapperStyle = {
        width: `${this.slideWidth}px`
      };
    });
  
    setInterval(() => {
      this.itemWidth = 50 * 4;
      this.next();
    }, 2000);
  }




}
